//parameters

//get the matrix stuff
float4x4 tWVP : WORLDVIEWPROJECTION;

//create a texture input
texture tex1;
sampler Samp1 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (tex1);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
    //BorderColor = (col);
};

texture tex2;
sampler Samp2 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (tex2);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Wrap;
    //BorderColor = (col);
};

//the tranform of the texture
float4x4 tTex : TEXTUREMATRIX;

float X = 0;

//data that flows from VS to the PS
struct vs2ps
{
   float4 pos : POSITION;
   float4 tex : TEXCOORD0;
};

//vertex shader
vs2ps myVS (float4 PosO : POSITION, //get the positions of the mesh
         float4 texCd : TEXCOORD0 //get the texture coords of the mesh
         )
{
     //declare output type
     vs2ps Out;

     //fill the output struct
     Out.pos = mul(PosO, tWVP);
     Out.tex = mul(texCd, tTex);

     //return the out struct
     return Out;
}

//pixel shader
float4 myPS (vs2ps In) : COLOR //must return a color
{
    //get the color from the texture
    float2 tmpCd = In.tex;
    tmpCd.x += X;

    float4 offset = tex2D(Samp1, tmpCd);

    tmpCd.xy += offset;
    float4 colFromTexture = tex2D(Samp1, tmpCd);
    
    //... and return it
    return colFromTexture;
}

// techniques
technique myTec
{
   pass myPass
   {
        VertexShader = compile vs_1_1 myVS();
        PixelShader = compile ps_2_0 myPS();
   }

}









